// ************************************************************************ //
// The types declared in this file were generated from data read from the
// WSDL File described below:
// WSDL     : http://www.ebob42.com/cgi-bin/UCCode.exe/wsdl/ISourceCode
// Encoding : utf-8
// Version  : 1.0
// (2004-07-16 13:57:36 - 1.33.2.5)
// ************************************************************************ //

unit ISourceCode1;

interface

uses InvokeRegistry, SOAPHTTPClient, Types, XSBuiltIns;

type

  // ************************************************************************ //
  // The following types, referred to in the WSDL document are not being represented
  // in this file. They are either aliases[@] of other types represented or were referred
  // to but never[!] declared in the document. The types from the latter category
  // typically map to predefined/known XML or Borland types; however, they could also 
  // indicate incorrect WSDL documents that failed to declare or import a schema type.
  // ************************************************************************ //
  // !:int             - "http://www.w3.org/2001/XMLSchema"
  // !:string          - "http://www.w3.org/2001/XMLSchema"
  // !:TSOAPAttachment - "http://www.borland.com/namespaces/Types"


  // ************************************************************************ //
  // Namespace : urn:SourceCodeIntf-ISourceCode
  // soapAction: urn:SourceCodeIntf-ISourceCode#%operationName%
  // transport : http://schemas.xmlsoap.org/soap/http
  // style     : rpc
  // binding   : ISourceCodebinding
  // service   : ISourceCodeservice
  // port      : ISourceCodePort
  // URL       : http://www.ebob42.com/cgi-bin/UCCode.exe/soap/ISourceCode
  // ************************************************************************ //
  ISourceCode = interface(IInvokable)
  ['{B183EAF6-88F2-4611-DB20-AD4197E98D1F}']
    function  LatestIssue: Integer; stdcall;
    procedure UnderConstruction(const IssueNr: Integer; var Title: WideString; var Summary: WideString; var Source: Integer); stdcall;
    function  GetSourceCode(const IssueNr: Integer): TSOAPAttachment; stdcall;
  end;

function GetISourceCode(UseWSDL: Boolean=System.False; Addr: string=''; HTTPRIO: THTTPRIO = nil): ISourceCode;


implementation

function GetISourceCode(UseWSDL: Boolean; Addr: string; HTTPRIO: THTTPRIO): ISourceCode;
const
  defWSDL = 'http://www.ebob42.com/cgi-bin/UCCode.exe/wsdl/ISourceCode';
  defURL  = 'http://www.ebob42.com/cgi-bin/UCCode.exe/soap/ISourceCode';
  defSvc  = 'ISourceCodeservice';
  defPrt  = 'ISourceCodePort';
var
  RIO: THTTPRIO;
begin
  Result := nil;
  if (Addr = '') then
  begin
    if UseWSDL then
      Addr := defWSDL
    else
      Addr := defURL;
  end;
  if HTTPRIO = nil then
    RIO := THTTPRIO.Create(nil)
  else
    RIO := HTTPRIO;
  try
    Result := (RIO as ISourceCode);
    if UseWSDL then
    begin
      RIO.WSDLLocation := Addr;
      RIO.Service := defSvc;
      RIO.Port := defPrt;
    end else
      RIO.URL := Addr;
  finally
    if (Result = nil) and (HTTPRIO = nil) then
      RIO.Free;
  end;
end;


initialization
  InvRegistry.RegisterInterface(TypeInfo(ISourceCode), 'urn:SourceCodeIntf-ISourceCode', 'utf-8');
  InvRegistry.RegisterDefaultSOAPAction(TypeInfo(ISourceCode), 'urn:SourceCodeIntf-ISourceCode#%operationName%');

end.